/**
  FoxyProxy - Take back your privacy!
  Copyright (C) 2006 Eric H. Jung and LeahScape, Inc.
  http://foxyproxy.mozdev.org/
  eric.jung@yahoo.com

  This source code is released under the GPL license,
  available in the LICENSE file at the root of this installation
  and also online at http://www.gnu.org/licenses/gpl.txt
**/

// See http://forums.mozillazine.org/viewtopic.php?t=308369

const CI = Components.interfaces, CC = Components.classes, CR = Components.results;      
gMatchingProxyFactory = function(proxy, aMatch, uri, type) {
  var matchingProxy = CC["@leahscape.org/foxyproxy/matchingproxy;1"].createInstance(CI.nsISupports).wrappedJSObject;
  matchingProxy.init(proxy, aMatch, uri, type);
	return matchingProxy;    
}

function foxyproxy() {this.wrappedJSObject = this;}

foxyproxy.prototype = {
	classID: Components.ID("{12fc70d0-5ae7-11da-8cd6-0800200c9a66}"),
	contractID: "@leahscape.org/foxyproxy/foxyproxy;1",
	classDescription: "FoxyProxy XPCOM",
	
	PFF : " ",
  _mode : "patterns",
  _selectedProxy : null,
  _selectedTabIndex : 0,
  _proxyDNS : false,
  _initialized : false,
  _pacLoadNotification : false,
  _pacErrorNotification : false, 
  _toolsMenu : true,
  _contextMenu : true, 
  _toolsMenuNode : null,
  _contextMenuNode : null,
    	
	QueryInterface: function(aIID) {
		if(!aIID.equals(CI.nsISupports) && !aIID.equals(CI.nsIObserver) && !aIID.equals(CI.nsISupportsWeakReference))
			throw CR.NS_ERROR_NO_INTERFACE;			
		return this;
	},

	observe: function(aSubject, aTopic, aData) {
		switch(aTopic) {
			case "app-startup":
				var obsSvc = CC["@mozilla.org/observer-service;1"].getService(CI.nsIObserverService);
				obsSvc.addObserver(this, "quit-application", false);
				obsSvc.addObserver(this, "domwindowclosed", false);
				break;
			case "domwindowclosed":
			  this.closeAppWindows("foxyproxy");
			  this.closeAppWindows("foxyproxy-options");			  
				break;
		}
	},
	
	closeAppWindows: function(type) {
    var wm = CC["@mozilla.org/appshell/window-mediator;1"].getService(CI.nsIWindowMediator);
    var win = wm.getMostRecentWindow("navigator:browser");
    if (!win)
      for (var e=wm.getEnumerator(type);e.hasMoreElements(); e.getNext().close());
	},
	
	loadScript : function(filename) {
    CC["@mozilla.org/moz/jssubscript-loader;1"].getService(CI.mozIJSSubScriptLoader)
      .loadSubScript(CC["@mozilla.org/network/io-service;1"]
      .getService(CI.nsIIOService).newURI(filename, null, null).QueryInterface(CI.nsIURL).spec);	
	},
		
	init2 : function() {
	  if (!this._initialized) {
	    this._initialized = true; // because @mozilla.org/file/directory_service;1 isn't available in init()
	    
			this.autoadd.match = CC["@leahscape.org/foxyproxy/match;1"].createInstance(CI.nsISupports).wrappedJSObject;
			this.autoadd.match.isMultiLine = true;
			this.autoadd.match.name = this.autoadd.matchName;
							    
      var req = CC["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance(CI.nsIXMLHttpRequest);
      var settingsURI = this.getSettingsURI("uri-string");
      req.open("GET", settingsURI, false); 
      req.send(null);
      var doc = req.responseXML, docElem = doc.documentElement;
      if (docElem.nodeName == "parsererror") {
        this.alert(null, this.getMessage("settings.error"));
        // TODO: prompt user to overwrite?
        this.writeSettings(settingsURI);
      }
      else
      	this.fromDOM(doc, docElem);
      	
      /*
	      <menu id="foxyproxy-tools-menu-1" label="&foxyproxy.label;" insertbefore="devToolsSeparator" position="9"
	        tooltiptext="&foxyproxy.tooltip;" accesskey="&foxyproxy.accesskey;" class="menu-iconic foxyproxybutton-small">
	      	<menupopup id="foxyproxy-contextmenu-popup"
	          onpopupshowing="foxyproxy.onPopupShowing(this, event);"
	          onpopuphiding="foxyproxy.onPopupHiding();"/>
		    </menu>
	    */

	  	var doc = CC["@mozilla.org/xml/xml-document;1"].createInstance(CI.nsIDOMDocument);
	    this._toolsMenuNode = doc.createElement("menu");	
	    this._toolsMenuNode.setAttribute("id", "foxyproxy-tools-menu-1");
	    this._toolsMenuNode.setAttribute("label", "&foxyproxy.label;");
	    this._toolsMenuNode.setAttribute("insertbefore", "devToolsSeparator");	 	    
	    this._toolsMenuNode.setAttribute("position", "9");	 	
	    this._toolsMenuNode.setAttribute("tooltiptext", "&foxyproxy.tooltip;");	 	
	    this._toolsMenuNode.setAttribute("accesskey", "&foxyproxy.accesskey;");	 	
	    this._toolsMenuNode.setAttribute("class", "menu-iconic foxyproxybutton-small");	    	    	    	    
	    var menupopup1 = doc.createElement("menupopup");
	    menupopup1.setAttribute("id", "foxyproxy-toolsmenu-popup");
	    menupopup1.setAttribute("onpopupshowing", "foxyproxy.onPopupShowing(this, event);");	    
	    menupopup1.setAttribute("onpopuphiding", "foxyproxy.onPopupHiding();");	    
	    this._toolsMenuNode.appendChild(menupopup1);
	        
	    /*
		  	<menu id="foxyproxy-context-menu-1" label="&foxyproxy.label;"
		      tooltiptext="&foxyproxy.tooltip;" accesskey="&foxyproxy.accesskey;" class="menu-iconic foxyproxybutton-small"> 
		      <menupopup id="foxyproxy-contextmenu-popup"
		          onpopupshowing="foxyproxy.onPopupShowing(this, event);"
		          onpopuphiding="foxyproxy.onPopupHiding();"/>
		    </menu>	    
	    */
	    
	    this._contextMenuNode = doc.createElement("menu");
	    this._contextMenuNode.setAttribute("id", "foxyproxy-context-menu-1");	    
	    this._contextMenuNode.setAttribute("label", "&foxyproxy.label;");	 	    
	    this._contextMenuNode.setAttribute("tooltiptext", "&foxyproxy.tooltip;");		    
	    this._contextMenuNode.setAttribute("accesskey", "&foxyproxy.accesskey;");			    
	    this._contextMenuNode.setAttribute("class", "menu-iconic foxyproxybutton-small");			 
	    var menupopup2 = doc.createElement("menupopup");
	    menupopup2.setAttribute("id", "foxyproxy-contextmenu-popup");
	    menupopup2.setAttribute("onpopupshowing", "foxyproxy.onPopupShowing(this, event);");	    
	    menupopup2.setAttribute("onpopuphiding", "foxyproxy.onPopupHiding();");	    
	    this._contextMenuNode.appendChild(menupopup2);	       	    
    }
	},
	
	get toolsMenuNode() {
		return this._toolsMenuNode.cloneNode(true);
	},

	get contextMenuNode() {
		return this._contextMenuNode.cloneNode(true);
	},	

  get mode() { return this._mode; },
  setMode : function(mode, writeSettings, init) {
    for (var i=0,len=this.proxies.length; i<len; i++) {
      if (mode == this.proxies.item(i).id) {
        this._selectedProxy = this.proxies.item(i);
        this.proxies.item(i).enabled = true; // ensure it's enabled
        break;
      }
    }
    this._mode = mode;
    if (init) return;    
    writeSettings && this.writeSettings();
    this.callFcnOnOverlays("toggleFilter", mode != "disabled");
    this.statusbar.enabled && this.callFcnOnOverlays("setMode", mode);    
  },
    
  callFcnOnOverlays : function(fcn, args) {
    for (var e = CC["@mozilla.org/appshell/window-mediator;1"]
      .getService(CI.nsIWindowMediator)
      .getEnumerator("navigator:browser"); e.hasMoreElements();) {
      win = e.getNext();
      win.foxyproxy && win.foxyproxy[fcn](args);
    }
  }, 	
  
	getPrefsService : function(str) {
    return CC["@mozilla.org/preferences-service;1"].
      getService(CI.nsIPrefService).getBranch(str);
  },
  
  // Returns settings URI in desired form
  getSettingsURI : function(type) {
    var o = null;
    try {
      o = this.getPrefsService("extensions.foxyproxy.").getCharPref("settings");
    }
    catch(e) {}
    if (o) {
      o == this.PFF && (o = this.getDefaultPath());
      var file = this.transformer(o, CI.nsIFile);
      // Does it exist?      
      if (!file.exists()) {
        this.writeSettings(file);
      }
    }
    else {
      // Default settings file/path
  	  o = this.setSettingsURI(this.getDefaultPath());
    }
    return this.transformer(o, type);
  },

  setSettingsURI : function(o) {
    var o2 = this.transformer(o, "uri-string");
    try {
  	  this.writeSettings(o2);
  	  // Only update the preference if writeSettings() succeeded
      this.getPrefsService("extensions.foxyproxy.").setCharPref("settings", o==this.PFF ? this.PFF : o2);  	  
    }
    catch(e) {
      this.alert(this, this.getMessage("error") + ":\n\n" + e);
    }
    return o==this.PFF ? this.PFF : o2;
  },

  isUsingPFF : function() {
    return this.getPrefsService("extensions.foxyproxy.").getCharPref("settings") == this.PFF;
  },
  
  alert : function(wnd, str) {
    CC["@mozilla.org/embedcomp/prompt-service;1"].getService(CI.nsIPromptService)
      .alert(null, this.getMessage("foxyproxy"), str);
  },  

  getDefaultPath : function() {
    var file = CC["@mozilla.org/file/local;1"].createInstance(CI.nsILocalFile);
    var dir = CC["@mozilla.org/file/directory_service;1"].getService(CI.nsIProperties).get("ProfD", CI.nsILocalFile);
    file.initWithPath(dir.path);
    file.appendRelativePath("foxyproxy.xml"); 
    return file; 
  },

  // Convert |o| from:
  //   - string of the form c:\path\eric.txt
  //   - string of the form file:///c:/path/eric.txt
  //   - nsIFile
  //   - nsIURI
  //   - null: implies use of PFF
  // to any of the other three types. Valid values for |desiredType|:
  //   - "uri-string"
  //   - "file-string"
  //   - Components.interfaces.nsIFile
  //   - Components.interfaces.nsIURI
  transformer : function(o, desiredType) {
    o == this.PFF && (o = this.getDefaultPath());
    const handler = CC["@mozilla.org/network/io-service;1"].
              getService(CI.nsIIOService).getProtocolHandler("file").
              QueryInterface(CI.nsIFileProtocolHandler);
    
    switch(desiredType) {
      case "uri-string":
        switch(typeof(o)) {
          case "string":
            if (o.indexOf("://" > -1)) return o;
            return handler.getURLSpecFromFile(this.createFile(o));
          case "object":
            if (o instanceof CI.nsIFile) return handler.getURLSpecFromFile(o);
            if (o instanceof CI.nsIURI) return o.spec;
            return null; // unknown type
        }
      case "file-string":
        switch(typeof(o)) {
          case "string":
            if (o.indexOf("://" > -1)) return handler.getFileFromURLSpec(o).path;
            return o;
          case "object":
            if (o instanceof CI.nsIFile) return o.path;
            if (o instanceof CI.nsIURI) return handler.getFileFromURLSpec(o.spec).path;
            return null; // unknown type                                
        }
      case CI.nsIFile:
        switch(typeof(o)) {
          case "string":
            if (o.indexOf("://" > -1)) return handler.getFileFromURLSpec(o);
            return this.createFile(o).path;
          case "object":
            if (o instanceof CI.nsIFile) return o;
            if (o instanceof CI.nsIURI) return handler.getFileFromURLSpec(o.spec);
            return null; // unknown type            
        }
      case CI.nsIURI:
        var ios = CC["@mozilla.org/network/io-service;1"].getService(CI.nsIIOService);
        switch(typeof(o)) {
          case "string":
            if (o.indexOf("://" > -1)) return ios.newURI(o, null, null);
            return handler.newFileURI(this.createFile(o));
          case "object":
            if (o instanceof CI.nsIFile) return handler.newFileURI(o);
            if (o instanceof CI.nsIURI) return o;
            return null; // unknown type          
        }
    }
        
  },
    // Create nsIFile from a string
  createFile : function(str) {
    var f = CC["@mozilla.org/file/local;1"].createInstance(CI.nsILocalFile);
    f.initWithPath(str);
    return f;
  },
  
  _prolog : "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n",
  writeSettings : function(o) {
    !o && (o = this.getPrefsService("extensions.foxyproxy.").getCharPref("settings"));
    o = this.transformer(o, CI.nsIFile);
    var foStream = CC["@mozilla.org/network/file-output-stream;1"].
      createInstance(CI.nsIFileOutputStream);
    foStream.init(o, 0x02 | 0x08 | 0x20, 0664, 0); // write, create, truncate
    foStream.write(this._prolog, this._prolog.length);
    CC["@mozilla.org/xmlextras/xmlserializer;1"].createInstance(CI.nsIDOMSerializer)
      .serializeToStream(this.toDOM(), foStream, "UTF-8");    
    //foStream.write(str, str.length);
    foStream.close();  
  },
  
  get proxyDNS() { return this._proxyDNS; },
  set proxyDNS(p) {
    this._proxyDNS = p;
    this.writeSettings();
  },

  get selectedTabIndex() { return this._selectedTabIndex; },
  set selectedTabIndex(i) {
    this._selectedTabIndex = i;
    this.writeSettings();
  },

  get logging() { return this.logg.enabled; },
  set logging(e) {
    this.logg.enabled = e;
    this.writeSettings();
  },

  get pacLoadNotification() { return this._pacLoadNotification; },
  set pacLoadNotification(n) {
    this._pacLoadNotification = n;
    this.writeSettings();
  },  
  
  get pacErrorNotification() { return this._pacErrorNotification; },
  set pacErrorNotification(n) {
    this._pacErrorNotification = n;
    this.writeSettings();
  },    

  get toolsMenu() { return this._toolsMenu; },
  set toolsMenu(n) {
    this._toolsMenu = n;
    this.callFcnOnOverlays("toggleToolsMenu", n);
    this.writeSettings();
  },   

  get contextMenu() { return this._contextMenu; },
  set contextMenu(n) {
    this._contextMenu = n;
    this.callFcnOnOverlays("toggleContextMenu", n);
    this.writeSettings();
  },  
    
  getMatchingProxy : function(uri) {
    var matchingProxy;
    var uriStr = uri.spec;  
    switch (this.mode) {
      case "random":   
				//matchingProxy = this.proxies.getRandom(uriStr, this.random._includeDirect, this.random._includeDisabled);
        //break;
      case "patterns":
	      matchingProxy = this.proxies.getMatches(uriStr);
        break;
      default:    
	      matchingProxy = gMatchingProxyFactory(this._selectedProxy, null, uriStr, "ded");      
        break;
    }
    this.logg.add(matchingProxy);
    //dump("name: " + matchingProxy.proxy.name+"\n");    
    return matchingProxy.proxy;
  },
  
  restart : function() {
		CC["@mozilla.org/toolkit/app-startup;1"].getService(CI.nsIAppStartup)
	  	.quit(CI.nsIAppStartup.eForceQuit|CI.nsIAppStartup.eRestart);
  },

	fromDOM : function(doc, node) {
		this.statusbar.fromDOM(doc);
		this.logg.fromDOM(doc); 
		this._proxyDNS = node.getAttribute("proxyDNS") == "true";
		this._pacLoadNotification = node.hasAttribute("pacLoadNotification") ?
			node.getAttribute("pacLoadNotification") == "true" : true; // new for 2.0
		this._pacErrorNotification = node.hasAttribute("pacErrorNotification") ?
			node.getAttribute("pacErrorNotification") == "true" : true; // new for 2.0		
		this._toolsMenu = node.hasAttribute("toolsMenu") ?
			node.getAttribute("toolsMenu") == "true" : true; // new for 2.0				
		this._contextMenu = node.hasAttribute("contextMenu") ?
			node.getAttribute("contextMenu") == "true" : true; // new for 2.0				
		this._selectedTabIndex = node.getAttribute("selectedTabIndex") || "0";
		this.proxies.fromDOM(doc, this);      
		this.setMode(node.hasAttribute("enabledState") ?
			(node.getAttribute("enabledState") == "" ? "patterns" : node.getAttribute("enabledState")) :
			node.getAttribute("mode"), false, true); // renamed to mode in 2.0
		this.random.fromDOM(doc, this);
    this.autoadd.fromDOM(doc);		
	},
	
	toDOM : function() {
  	var doc = CC["@mozilla.org/xml/xml-document;1"]
      .createInstance(CI.nsIDOMDocument);
    //var doc = document.implementation.createDocument("", "", null);
    var e = doc.createElement("foxyproxy");    
    e.setAttribute("mode", this._mode);
    e.setAttribute("selectedTabIndex", this._selectedTabIndex);
    e.setAttribute("proxyDNS", this._proxyDNS ? "true" : "false");
    e.setAttribute("pacLoadNotification", this._pacLoadNotification ? "true" : "false");    
    e.setAttribute("pacErrorNotification", this._pacErrorNotification ? "true" : "false");        
    e.setAttribute("toolsMenu", this._toolsMenu ? "true" : "false");    
    e.setAttribute("contextMenu", this._contextMenu ? "true" : "false");              
    e.appendChild(this.random.toDOM(doc));   
    e.appendChild(this.statusbar.toDOM(doc));
    e.appendChild(this.logg.toDOM(doc));
    e.appendChild(this.autoadd.toDOM(doc));  
    e.appendChild(this.proxies.toDOM(doc));       
    return e;
	},  
  
  ///////////////// random \\\\\\\\\\\\\\\\\\\\\\
	
	random : {
  	owner : null,
  	_includeDirect : false,
  	_includeDisabled : false,  	

	  get includeeDirect() { return this._includeDirect; },
	  set includeeDirect(e) {
	    this._includeDirect = e;
	    this.owner.writeSettings();
	  },	

	  get includeDisabled() { return this._includeDisabled; },
	  set includeDisabled(e) {
	    this._includeDisabled = e;
	    this.owner.writeSettings();
	  },
	
		toDOM : function(doc) {
			var e = doc.createElement("random");
			e.setAttribute("includeDirect", this._includeDirect ? "true":"false");		
			e.setAttribute("includeDisabled", this._includeDisabled ? "true":"false");				
		  return e;
		},
		
		fromDOM : function(doc) {
      var node = doc.getElementsByTagName("random")[0];
      if (node) { // because this is new for 2.0
      	this._includeDirect = node.getAttribute("includeDirect") == "true";
      	this._includeDisabled = node.getAttribute("includeDisabled") == "true";      	
			}
		}
	},
	
  ///////////////// proxies \\\\\\\\\\\\\\\\\\\\\\

  proxies : {
  	owner : null,
	  deadEnd : CC["@mozilla.org/network/protocol-proxy-service;1"]
			.getService(CI.nsIProtocolProxyService)
			.newProxyInfo("http", "", 0, 0, 0, null), // port 0, never ignore, never failover 
	  //deadEndMatchingProxy : gMatchingProxyFactory(this._selectedProxy, null, uriStr, "ded"),  
    list : [],
    push : function(p) {
      // not really a push: this inserts p
      //as the second-to-last item in the list
      if (this.list.length == 0)
        this.list[0] = p;
      else {
        var len = this.list.length-1;
        this.list[len+1] = this.list[len];
        this.list[len] = p;
	    }
	    return true;
    },

    get length() {
      return this.list.length;
    },
    
    getById : function(id) {
      var a = this.list.filter(function(e) {return e.id == this;}, id);
      return a?a[0]:null;
    },
        
    fromDOM : function(doc, fp) {
      var lastResort = null;
      for (var i=0,proxyElems=doc.getElementsByTagName("proxy"); i<proxyElems.length; i++) {
        var p = CC["@leahscape.org/foxyproxy/proxy;1"].createInstance(CI.nsISupports).wrappedJSObject;
        p.fromDOM(proxyElems[i]);
        if (!lastResort && proxyElems[i].getAttribute("lastresort") == "true")
          lastResort = p;
        else
        	this.list.push(p);
      }
      if (lastResort)     
        this.list.push(lastResort); // ensures it really IS last
      else {
	      lastResort = CC["@leahscape.org/foxyproxy/proxy;1"].createInstance(CI.nsISupports).wrappedJSObject;
        lastResort.name = fp.getMessage("proxy.default");
        lastResort.notes = fp.getMessage("proxy.default.notes");
        lastResort.mode = "direct";
        lastResort.lastresort = true;
        var match = CC["@leahscape.org/foxyproxy/match;1"].createInstance(CI.nsISupports).wrappedJSObject;
        match.name = fp.getMessage("proxy.default.match.name");
        match.pattern = "*";
        lastResort.matches.push(match);
        lastResort.selectedTabIndex = 1;
        this.list.push(lastResort); // ensures it really IS last
        fp.writeSettings();
  		}
    },
    
    toDOM : function(doc) {
			var proxiesElem=doc.createElement("proxies");
      for (var i=0; i<this.list.length; i++)
        proxiesElem.appendChild(this.list[i].toDOM(doc));
      return proxiesElem;
    },
    
    item : function(i) { 
      return this.list[i];
    },
    
    remove : function(idx) {
      this.maintainIntegrity(this.list[idx], true, false, false);
      for (var i=0, temp=[]; i<this.list.length; i++) {
        if (i != idx) temp[temp.length] = this.list[i];
      }
      this.list = []; //this.list.splice(0, this.length);
      for (var i=0; i<temp.length && this.list.push(temp[i]); i++);
    },
    
    move : function(idx, direction) {
      var newIdx = idx + (direction=="up"?-1:1);
      if (newIdx < 0 || newIdx > this.list.length-1) return false;
      var temp = this.list[idx]; 
      this.list[idx] = this.list[newIdx];
      this.list[newIdx] = temp;
      return true;
    },
    
    getMatches : function(uri) {
			for (var i=0, aMatch; i<this.list.length; i++) {
			  // todo: how expensive is next line?
			  if (this.list[i]._mode == "auto" &&
			  	!this.list[i].autoconf._resolver.getProxyForURI(uri.spec, uri.host)) continue; // skip if PAC returns null for this uri
			
				if (this.list[i]._enabled && (aMatch = this.list[i].isMatch(uri))) {
					return gMatchingProxyFactory(this.list[i], aMatch, uri, "pat");
				}
      }
    },
    
    getRandom : function(uri, includeDirect, includeDisabled) {
      var isDirect = true, isDisabled = true, r, cont, maxTries = this.list.length*10;
      do {
        r = Math.floor(Math.random()*this.list.length); // Thanks Andrew @ http://www.shawnolson.net/a/789/   
        dump(r+"\n");     
        cont = (!includeDirect && this.list[r].mode == "direct") ||
        	(!includeDisabled && !this.list[r]._enabled);
         dump("cont="+cont+"\n");
      } while (cont && (--maxTries > 0));
      if (maxTries == 0)
        return this.deadEnd;
      return gMatchingProxyFactory(this.list[r], null, uri, "rand");   
    },
    
    uniqueRandom : function() {
      var unique = true, r;
      do {
        r = Math.floor(Math.random()*4294967296); // Thanks Andrew @ http://www.shawnolson.net/a/789/
        for (var i=0; i<this.list.length && unique; i++)
          this.list[i].id == r && (unique = false);
      } while (!unique);
      return r;
    },
    
    maintainIntegrity : function(proxy, isBeingDeleted, isBeingDisabled, isBecomingDIRECT) {
      var updateViews;
      // Handle mode
      if (isBeingDeleted || isBeingDisabled) {
	      if (this.owner._mode == proxy.id) {
	        this.owner.setMode("disabled", true);
	        updateViews = true;
	      }
	    }
	    // Handle AutoAdd
	    if (this.owner.autoadd.proxy && this.owner.autoadd.proxy.id == proxy.id) {
	      // Turn it off and reset it
	      this.owner.autoadd.enabled && (this.owner.autoadd.enabled = false);
	      updateViews = true;
	      if (isBeingDeleted) {
		      this.owner.autoadd.proxy = null;	      
	        updateViews = true;
	      }
	    }
      // updateViews() with false, false (do not write settings and do not update log view--settings were just written when the properties themselves were updated
      updateViews && this.owner.callFcnOnOverlays("updateViews");
    }  
  },
  
  ///////////////// log \\\\\\\\\\\\\\\\\\\\\\\\\\\
  logg : {
    _maxSize : 500,
    _elements : new Array(this._maxSize),    
    _end : 0,
    _start : 0,
    _full : false,
    enabled : false,

    fromDOM : function(doc) {
      var node = doc.getElementsByTagName("logg")[0];
      this.enabled = node.getAttribute("enabled") == "true";
      this._maxSize = node.hasAttribute("maxSize") ?
	      node.getAttribute("maxSize") : 500; // new for 2.0
	    this.clear();
    },
    
    toDOM : function(doc) {
      var e = doc.createElement("logg");
      e.setAttribute("enabled", this.enabled ? "true" : "false");
      e.setAttribute("maxSize", this.maxSize);      
      return e;    
    },
    
    get length() {
      var size = 0;
      if (this._end < this._start) {
          size = this._maxSize - this._start + this._end;
      } else if (this._end == this._start) {
         size = (this._full ? this._maxSize : 0);
      } else {
          size = this._end - this._start;
      }
      return size;
    },
    
    get maxSize() {
      return this._maxSize;
    },
    
    set maxSize(m) {
      this._maxSize = m;
      this.clear();
    },
  
    clear : function() {
      this._full = false;
      this._end = this._start = 0;
      //this._elements.forEach(function(element, index, array) {array[index] = null;});
      this._elements = new Array(this._maxSize);
    },
  
    add : function(o) {
      if (!this.enabled) return;
      this.length == this._maxSize && this._remove();
      this._elements[this._end++] = o;
      this._end >= this._maxSize && (this._end = 0);
      this._end == this._start && (this._full = true);
    },
  
    item : function(idx) {
      return this.length == 0 ? null : this._elements[idx];
    },
  
    _remove : function() {
      if (this.length == 0)
        return;
      var element = this._elements[this._start];
  
      if (element) {
        this._elements[this._start++] = null;
        this._start >= this._maxSize && (this._start = 0);
        this._full = false;
      }
    }
  },

  ///////////////// notifier \\\\\\\\\\\\\\\\\\\\\\\\\\\
  // Thanks for the inspiration: InfoRSS extension (Didier Ernotte, 2005)
  notifier : {    
  	alerts : function() {
      try {
        return CC["@mozilla.org/alerts-service;1"].getService(CI.nsIAlertsService);  
      }
      catch(e) {return null;}
  	}(),
  	
    notify : function(title, text) {   
      text = this._makeFriendly(text);
      if (this.alerts)
        this.alerts.showAlertNotification("chrome://foxyproxy/content/foxyproxy-trans-icon.gif", title, text, false, "cookie", null);
      else {
        var tooltip = document.getElementById("foxyproxy-popup");
        this._removeChildren(tooltip);
    		var grid = document.createElement("grid");
    		grid.setAttribute("flex", "1");
    		tooltip.appendChild(grid);
    
    		var columns = document.createElement("columns");
    		columns.appendChild(document.createElement("column")); 		
    		grid.appendChild(columns);
    
    		var rows = document.createElement("rows");
    		grid.appendChild(rows);
        this._makeHeaderRow(title, rows);
        this._makeRow("", rows);
        this._makeRow(text, rows);
        tooltip.showPopup(document.getElementById("status-bar"), -1, -1, "tooltip", "topright","bottomright");
      }
    },

    _makeHeaderRow : function(col, gridRows) {
  		var label = document.createElement("label");
  		label.setAttribute("value", col);      
      label.setAttribute("style", "font-weight: bold; text-decoration: underline; color: blue;");
      gridRows.appendChild(label);    
    },
    
    _makeRow : function(col1, gridRows) {
  		var gridRow = document.createElement("row");
  		var label = document.createElement("label");
  		label.setAttribute("value", col1);    
  		gridRow.appendChild(label);
  		gridRows.appendChild(gridRow);  
    },
      
    _removeChildren : function(node) {
      if (node.firstChild) {
        node.removeChild(node.firstChild);
        this._removeChildren(node);
      }
    },
    
    _makeFriendly : function(str) {
      return str.length > 50 ? (str.substring(0, 50) + "...") : str;
    }, 
  },
  
  ///////////////// statusbar \\\\\\\\\\\\\\\\\\\\\
  statusbar : {    
    owner : null,
    _enabled : true,
        
    toDOM : function(doc) {
      var e = doc.createElement("statusbar");
      e.setAttribute("enabled", this._enabled ? "true" : "false");
      return e;
    },
    
    fromDOM : function(doc) {
      var node = doc.getElementsByTagName("statusbar")[0];
      this._enabled = node && node.getAttribute("enabled") == "true";
    },
    
    get enabled() { return this._enabled; },
    set enabled(e) {
      this._enabled = e;
      this.owner.writeSettings();
      this.owner.callFcnOnOverlays("toggleStatusBar");
      e && this.owner.setMode(this.owner.mode, false, false);          
    }
  },
  
  ///////////////// strings \\\\\\\\\\\\\\\\\\\\\ 
  getMessage : function(msg, ar) {
    try {
      return this.strings.getMessage(msg, ar);
    }
    catch (e) {
      dump(e);
      this.alert(null, "Error reading string resource: " + msg); // Do not localize!
    }
  },  
  
  strings : {
    _sbs : CC["@mozilla.org/intl/stringbundle;1"]
      .getService(CI.nsIStringBundleService)
      .createBundle("chrome://foxyproxy/locale/foxyproxy.properties"),    
    _entities : null,
    
    getMessage : function(msg, ar) {
      return ar ? this._sbs.formatStringFromName(msg, ar, ar.length) :
        (this._entities[msg] ? this._entities[msg] : this._sbs.GetStringFromName(msg));
    }
  },

  ///////////////// autoadd \\\\\\\\\\\\\\\\\\\\\\  
  autoadd : {
    owner : null,
    _reload : true,
  	_enabled : false,
  	_proxy : null,
  	_notify : true,
		match : null,
		matchName : null,
		
		_urlTemplate : "*${1}/*",
		_ios : CC["@mozilla.org/network/io-service;1"].getService(CI.nsIIOService),

    get enabled() { return this._enabled; },
    set enabled(e) {
      this._enabled = e;
      this.owner.writeSettings();
      this.owner.callFcnOnOverlays("togglePageLoad", e);    
    },

    get urlTemplate() { return this._urlTemplate; },
    set urlTemplate(u) {
    	this._urlTemplate = u;
    	this.owner.writeSettings();
    },    

    get reload() { return this._reload; },
    set reload(e) {
    	this._reload = e;
    	this.owner.writeSettings();
    },    

    get proxy() { return this._proxy; },
    set proxy(p) {
    	this._proxy = p;
    	this.owner.writeSettings();
    },    

    get notify() { return this._notify; },
    set notify(n) {
    	this._notify = n;
    	this.owner.writeSettings();
    },
                
    setMatchPattern : function(p) {
      this.match.pattern = p;
      this.owner.writeSettings();
    },
    
    setMatchIsRegEx : function(e) {
      this.match.isRegEx = e;
      this.owner.writeSettings();      
    },
    
    applyTemplate : function(url) {    	
	    var parsedUrl = this._ios.newURI(url, "UTF-8", null).QueryInterface(CI.nsIURL);	
	    return this._urlTemplate.replace("${1}", parsedUrl.asciiHost, "g");    
    },
    
    perform : function(url, content) {
      if (this.match.pattern != "") {
        var d = new Date();
        if (this.match.regex.test(content)) {
          dump((new Date()-d) + "\n");
	        if (this.owner.getMatchingProxy(url).id == this.owner.proxies.item(this.owner.proxies.length-1).id) {
	          if (!this._proxy.isMatch(url)) {        
							var temp = this.applyTemplate(url);                  
							var match = CC["@leahscape.org/foxyproxy/match;1"].createInstance(CI.nsISupports).wrappedJSObject;
				      match.name = this.matchName;			      
			  	    match.pattern = temp;
				  	  match.isRegEx = this.match.isRegEx; // todo: make this dynamic
				      this._proxy.matches.push(match);      
						  this._notify && this.owner.notifier.notify(this.owner.getMessage("autoadd.notify"), this.owner.getMessage("autoadd.url.added", [temp, this._proxy.name]));        
		          this.owner.writeSettings();
			        return true;
			      }
			    }
	      }
	    }
      return false;
    }, 
    
    allowed : function() {
		  for (var i=0,p; i<this.owner.proxies.length && (p=this.owner.proxies.item(i)); i++)
		    if (p.mode!="direct" && p.enabled)
		      return true;
		  return false;
    },
    
    toDOM : function(doc) {
			var e = doc.createElement("autoadd");
			e.setAttribute("enabled", this.enabled ? "true" : "false");
			e.setAttribute("urlTemplate", this._urlTemplate);
			e.setAttribute("reload", this._reload);			
			e.setAttribute("notify", this._notify);
			this._proxy && e.setAttribute("proxy-id", this._proxy.id);
			e.appendChild(this.match.toDOM(doc));
      return e;
    },
    
		fromDOM : function(doc) {
      var n = doc.getElementsByTagName("autoadd")[0]; // new for 2.0
      var proxyId;
      if (n) { // because it won't exist for ppl upgrading from 1.0
	      this._enabled = n.getAttribute("enabled") == "true";
	      this._urlTemplate = n.getAttribute("urlTemplate");
	      ((!this._urlTemplate || this._urlTemplate == "") && (this._urlTemplate = "*${1}/*"));
	      this._reload = n.getAttribute("reload") == "true";      
	      this._notify = n.getAttribute("notify") == "true";      	      	      
	      proxyId = n.getAttribute("proxy-id");
        this.match.fromDOM(n.getElementsByTagName("match")[0]);   
        (!this.match.name || this.match.name == "") && (this.match.name = this.owner.getMessage("foxyproxy.autoadd.pattern.name.default.label"));
				this.match.isMultiLine = true;        
	    }
	    var error;
	    if (proxyId) {
	      // Ensure it exists and is enabled and isn't "direct"
	      this._proxy = this.owner.proxies.getById(proxyId);
	      this._enabled && (!this._proxy || !this._proxy.enabled || this._proxy.mode == "direct") && (error = true);
	    }
	    else if (this._enabled)
	    	error = true;
	    if (error) {
        this._enabled = false;
        this.owner.alert(null, this.owner.getMessage("autoadd.error"));
      }	    
		}    
	}
};

// Initializations
function init(fp) {
	fp.proxies.owner = fp.autoadd.owner = fp.random.owner = fp.statusbar.owner = fp;

  var req = CC["@mozilla.org/xmlextras/xmlhttprequest;1"].
    createInstance(CI.nsIXMLHttpRequest);
  req.open("GET", "chrome://foxyproxy/content/strings.xml", false);
  req.send(null);  
  foxyproxy.prototype.strings._entities = new Array();      
  for (var i=0,e=req.responseXML.getElementsByTagName("i18n"); i<e.length; i++)  {
    var attrs = e.item(i).attributes;
    foxyproxy.prototype.strings._entities[attrs.getNamedItem("id").nodeValue] = attrs.getNamedItem("value").nodeValue;
  }
  fp.autoadd.matchName = fp.getMessage("autoadd.pattern.label");
  return fp;
}

// Constructors for objects we want to XPCOMify
var gXpComObjects = [foxyproxy];
var gCatObserverName = "foxyproxy_catobserver";
var gCatContractId = foxyproxy.prototype.contractID;

// Generic registration code
function NSGetModule(compMgr, fileSpec) {
	gModule._catObserverName = gCatObserverName;
	gModule._catContractId = gCatContractId;
	for (var i in gXpComObjects)
		gModule._xpComObjects[i] = new gFactoryHolder(gXpComObjects[i]);
	return gModule;
}

function gFactoryHolder(aObj) {
	this.CID        = aObj.prototype.classID;
	this.contractID = aObj.prototype.contractID;
	this.className  = aObj.prototype.classDescription;
	this.factory = {
		createInstance: function(aOuter, aIID) {
			if (aOuter) throw CR.NS_ERROR_NO_AGGREGATION;
			return init((new this.constructor).QueryInterface(aIID));			
		}
	};
	this.factory.constructor = aObj;
}

var gModule = {
	registerSelf: function (aComponentManager, aFileSpec, aLocation, aType) {
		aComponentManager.QueryInterface(CI.nsIComponentRegistrar);
		for (var key in this._xpComObjects) {
			var obj = this._xpComObjects[key];
			aComponentManager.registerFactoryLocation(obj.CID, obj.className,
			obj.contractID, aFileSpec, aLocation, aType);
		}
		
		var catman = CC["@mozilla.org/categorymanager;1"].getService(CI.nsICategoryManager);
		catman.addCategoryEntry("app-startup", this._catObserverName, "service," + this._catContractId, true, true);
		catman.addCategoryEntry("xpcom-shutdown", this._catObserverName, this._catContractId, true, true);
	},

	unregisterSelf: function(aCompMgr, aFileSpec, aLocation) {
		var catman = CC["@mozilla.org/categorymanager;1"].getService(CI.nsICategoryManager);
		catman.deleteCategoryEntry("app-startup", this._catObserverName, true);
		catman.deleteCategoryEntry("xpcom-shutdown", this._catObserverName, true);
		
		aComponentManager.QueryInterface(CI.nsIComponentRegistrar);
		for (var key in this._xpComObjects) {
			var obj = this._xpComObjects[key];
			aComponentManager.unregisterFactoryLocation(obj.CID, aFileSpec);
		}
	},

	getClassObject: function(aComponentManager, aCID, aIID)	{
		if (!aIID.equals(CI.nsIFactory))
			throw CR.NS_ERROR_NOT_IMPLEMENTED;
		
		for (var key in this._xpComObjects)
			if (aCID.equals(this._xpComObjects[key].CID))
				return this._xpComObjects[key].factory;
	
		throw CR.NS_ERROR_NO_INTERFACE;
	},

	canUnload: function(aComponentManager) { return true; },
	
	_xpComObjects: {},
	_catObserverName: null,
	_catContractId: null
};